Index: testsuites/libtests/dl04/init.c
===================================================================
--- testsuites/libtests/dl04/init.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
+++ testsuites/libtests/dl04/init.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -0,0 +1,84 @@
+/*
+ * Copyright (c) 2016 Chris Johns <chrisj@rtems.org>.  All rights reserved.
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.org/license/LICENSE.
+ */
+
+#ifdef HAVE_CONFIG_H
+  #include "config.h"
+#endif
+
+#include "tmacros.h"
+
+#include <errno.h>
+#include <string.h>
+#include <stdint.h>
+#include <unistd.h>
+
+#include <rtems/rtl/rtl.h>
+#include <rtems/untar.h>
+
+#include "dl-load.h"
+
+const char rtems_test_name[] = "libdl (RTL) 4";
+
+/* forward declarations to avoid warnings */
+static rtems_task Init(rtems_task_argument argument);
+
+#include "dl-tar.h"
+
+#define TARFILE_START dl_tar
+#define TARFILE_SIZE  dl_tar_size
+
+static int test(void)
+{
+  int ret;
+  ret = dl_load_test();
+  if (ret)
+    rtems_test_exit(ret);
+  return 0;
+}
+
+static void Init(rtems_task_argument arg)
+{
+  int te;
+
+  TEST_BEGIN();
+
+  te = Untar_FromMemory((void *)TARFILE_START, (size_t)TARFILE_SIZE);
+  if (te != 0)
+  {
+    printf("untar failed: %d\n", te);
+    rtems_test_exit(1);
+    exit (1);
+  }
+
+  test();
+
+  TEST_END();
+
+  rtems_test_exit(0);
+}
+
+#define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
+#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER
+
+#define CONFIGURE_LIBIO_MAXIMUM_FILE_DESCRIPTORS 4
+
+#define CONFIGURE_MAXIMUM_TASKS 1
+
+#define CONFIGURE_MINIMUM_TASK_STACK_SIZE (8U * 1024U)
+
+#define CONFIGURE_EXTRA_TASK_STACKS (8 * 1024)
+
+#define CONFIGURE_MAXIMUM_SEMAPHORES 1
+
+#define CONFIGURE_INITIAL_EXTENSIONS RTEMS_TEST_INITIAL_EXTENSION
+
+#define CONFIGURE_RTEMS_INIT_TASKS_TABLE
+
+#define CONFIGURE_INIT
+
+#include <rtems/confdefs.h>
Index: testsuites/libtests/dl05/Makefile.am
===================================================================
--- testsuites/libtests/dl05/Makefile.am	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
+++ testsuites/libtests/dl05/Makefile.am	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -0,0 +1,50 @@
+rtems_tests_PROGRAMS = dl05
+dl05_SOURCES = init.c dl-load.c dl-cpp.cpp dl-tar.c dl-tar.h
+
+BUILT_SOURCES = dl-tar.c dl-tar.h
+
+dist_rtems_tests_DATA = dl05.scn dl05.doc
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
+
+AM_CPPFLAGS += -I$(top_srcdir)/../support/include
+
+LINK_OBJS = $(dl05_OBJECTS)
+LINK_LIBS = $(dl05_LDLIBS)
+
+dl-o5.o: dl-o5.cpp
+
+dl.tar: dl-o5.o
+	@rm -f $@
+	$(PAX) -w -f $@ $<
+CLEANFILES += dl.tar
+
+dl-tar.c: dl.tar
+	$(BIN2C) -C $< $@
+CLEANFILES += dl-tar.c
+
+dl-tar.h: dl.tar
+	$(BIN2C) -H $< $@
+CLEANFILES += dl-tar.h
+
+dl05.pre$(EXEEXT): $(dl05_OBJECTS) $(dl05_DEPENDENCIES)
+	@rm -f dl05.pre$(EXEEXT)
+	$(LINK.cc) $(CPU_CFLAGS) $(AM_CFLAGS) $(AM_LDFLAGS) \
+		    -o $(basename $@)$(EXEEXT) $(LINK_OBJS) $(LINK_LIBS)
+	rm -f dl05.pre.ralf
+
+dl05.pre: dl05.pre$(EXEEXT)
+	mv $< $@
+CLEANFILES += dl05.pre
+
+dl-sym.o: dl05.pre
+	rtems-syms -e -c "$(CFLAGS)" -o $@ $<
+
+dl05$(EXEEXT):  $(dl05_OBJECTS) $(dl05_DEPENDENCIES) dl-sym.o
+	@rm -f dl05$(EXEEXT)
+	$(LINK.cc) $(CPU_CFLAGS) $(AM_CFLAGS) $(AM_LDFLAGS) \
+		    -o $(basename $@)$(EXEEXT) $(LINK_OBJS) dl-sym.o $(LINK_LIBS)
+
+include $(top_srcdir)/../automake/local.am
Index: testsuites/libtests/dl05/dl-cpp.cpp
===================================================================
--- testsuites/libtests/dl05/dl-cpp.cpp	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
+++ testsuites/libtests/dl05/dl-cpp.cpp	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -0,0 +1,30 @@
+/*
+ * The base image needs this to include the RTTI data.
+ */
+#include <cstdio>
+#include <stdexcept>
+#include "dl-load.h"
+void exception_base(bool throw_runtime)
+{
+  printf("%s: begin\n", __func__);
+  try
+  {
+    if (throw_runtime)
+      throw std::runtime_error("eb: throw std::runtime_error");
+    else
+      throw dl_test_throw_me("eb: throw me");
+  }
+  catch (std::exception const& e)
+  {
+    printf("%s: caught: %s\n", __func__, e.what());
+  }
+  catch (dl_test_throw_me const& e)
+  {
+    printf("%s: caught: %s\n", __func__, e.what());
+  }
+  catch (...)
+  {
+    printf("%s: caught: unknown\n", __func__);
+  }
+  printf("%s: end\n", __func__);
+}
Index: testsuites/libtests/dl05/dl-load.c
===================================================================
--- testsuites/libtests/dl05/dl-load.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
+++ testsuites/libtests/dl05/dl-load.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2016 Chris Johns <chrisj@rtems.org>.  All rights reserved.
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.org/license/LICENSE.
+ */
+
+#ifdef HAVE_CONFIG_H
+  #include "config.h"
+#endif
+
+#include "tmacros.h"
+
+#include <stdio.h>
+
+#include <dlfcn.h>
+
+#include <rtems/rtl/rtl-trace.h>
+
+#include "dl-load.h"
+
+int dl_load_test(void)
+{
+  void*       handle;
+  const char* err;
+  void        (*func)(bool );
+#if __i386__
+  /*
+   * std::runtime_error destructor locks up in atomics.
+   */
+  bool        throw_runtime = false;
+#else
+  bool        throw_runtime = true;
+#endif
+
+  rtems_rtl_trace_set_mask(RTEMS_RTL_TRACE_ALL);
+
+  handle = dlopen("/dl-o5.o", RTLD_GLOBAL | RTLD_NOW);
+  if (handle == NULL)
+  {
+    err = dlerror();
+    if (err != NULL)
+      printf("dlopen: %s\n", err);
+  }
+  rtems_test_assert(handle != NULL);
+
+  func = dlsym(handle, "exception_dl");
+  if (func == NULL) {
+    err = dlerror ();
+    if (err)
+      printf ("dlsym: %s\n", err);
+  }
+  rtems_test_assert(func != NULL);
+
+  exception_base(throw_runtime);
+
+  func(throw_runtime);
+
+  rtems_test_assert(dlclose(handle) == 0);
+
+  return 0;
+}
Index: testsuites/libtests/dl05/dl-load.h
===================================================================
--- testsuites/libtests/dl05/dl-load.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
+++ testsuites/libtests/dl05/dl-load.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -0,0 +1,51 @@
+/*
+ * Copyright (c) 2016 Chris Johns <chrisj@rtems.org>.  All rights reserved.
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.org/license/LICENSE.
+ */
+
+#if !defined(_DL_LOAD_H_)
+#define _DL_LOAD_H_
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+void exception_base(bool throw_runtime);
+void exception_dl(bool throw_runtime);
+
+int dl_load_test(void);
+
+#ifdef __cplusplus
+  class dl_test_throw_me
+  {
+  public:
+    dl_test_throw_me(const char* message) :
+      message (message) {
+    }
+    dl_test_throw_me(const dl_test_throw_me& orig) :
+      message (orig.message) {
+    }
+    dl_test_throw_me() :
+      message (0) {
+    }
+
+    ~dl_test_throw_me() {
+    }
+
+    const char* what() const {
+      return message;
+    }
+
+  private:
+    const char* message;
+  };
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
Index: testsuites/libtests/dl05/dl-o5.cpp
===================================================================
--- testsuites/libtests/dl05/dl-o5.cpp	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
+++ testsuites/libtests/dl05/dl-o5.cpp	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -0,0 +1,28 @@
+#include <cstdio>
+#include <stdexcept>
+#include "dl-load.h" /* make the symbol a C linkage */
+void exception_dl(bool throw_runtime)
+{
+  printf("exception_dl: begin\n");
+  try
+  {
+    printf("exception_dl: throwing...\n");
+    if (throw_runtime)
+      throw std::runtime_error("throw std::runtime_error object");
+    else
+      throw dl_test_throw_me("throw dl_test_throw_me object");
+  }
+  catch (dl_test_throw_me const& e)
+  {
+    printf("%s: caught: %s\n", __func__, e.what());
+  }
+  catch (std::exception const& e)
+  {
+    printf("%s: caught: %s\n", __func__, e.what());
+  }
+  catch (...)
+  {
+    printf("%s: caught: unknown\n", __func__);
+  }
+  printf("exception_dl: end\n");
+}
